--Initial Values
GAMBLE_POT = 0		-- pot size

GAMBLE_DROP_VALUES = {
	uncommon = 100000,
	rare = 100000,
	epic = 100000,
	nonplayer = 50000,
	ante = 100000,
	minbid = 100000,
	maxbid = 800000
	}	-- uncommon, rare, epic, nonplayer, your bet, minimum bet, maximum bet
	
GAMBLE_CONSTANTS = {
	jeopardychance = 10,
	doubleitemchance = 5,
	doubleitem = 2,
	base = 2,
	multiplier = 1,
	dryspelltime = 5,
	rolladdition = 10,
	upperlimit = 100
	}	-- chance out of 1k, base, multiplier, roll value, starting max roll value
	
GAMBLE_JEOPARDY = {
	streaktype = "none",
	streak = 0,
	dryspell = 0
	}	-- streak count, runs since last high stakes round

GAMBLE_STATS = {}		--saved stats of past games

GAMBLE_SAVED_VARS = {
	hidden = false,
	bet = 100000,
	client = false,
	gameinprogress = false,
	locked = false,
	usechaosorb = false,
	framehide = false,
	ignoreskips = false,
	savestats = true,
	savexserverstats = true,
	chatmessage = false,
	announceframe = true,
	bossbonusroll = true,
	players = {}
	}		--options and settings
	
GAMBLE_TARGETID = nil							-- frame id for stats frame deletion and posting
GAMBLE_INFOFRAME = {}							-- info to populate tooltip as client with game info

GAMBLE_PARTY_SIZE = 1							-- party/raid size for frame updating

-- throttle timers for certain features
GAMBLE_ANNOUNCE_THROTTLE = 0			-- announcement frame time out
GAMBLE_BOSSKILL_THROTTLE = 60			-- boss kill bonus reset (start at 60 so first boss counts)

--Game Start popup setup
StaticPopupDialogs["GambleStartConfirm"] = {
text = GAMBLE_POPUP_READY,
button1 = YES,
button2 = NO,
OnAccept = function (self) Gamble_TakeBets() end,
OnCancel = function (self) end,
hideOnEscape = 1,
timeout = 0,
}

--Game Abandon popup
StaticPopupDialogs["GambleAbandonConfirm"] = {
text = GAMBLE_POPUP_TERMINATE,
button1 = YES,
button2 = NO,
OnAccept = function (self) Gamble_ModComm_Send("game_terminate\a") Gamble_TerminateGame() end,
OnCancel = function (self) end,
hideOnEscape = 1,
timeout = 0,
}

--Setup slash commands for chatbox
SLASH_GAMBLE1 = "/gamble"
function SlashCmdList.GAMBLE(msg, editbox)
	Gamble_ToggleVisible()
end

function Gamble_ToggleVisible(hide)
	if Gamble:IsVisible() or hide then
		Gamble:Hide()
	else
		Gamble:Show()
	end
end

function Gamble_OnShow()
	GAMBLE_SAVED_VARS["hidden"] = false
end

function Gamble_OnHide()
	GAMBLE_SAVED_VARS["hidden"] = true
end

--Start it up
function Gamble_OnLoad()
	Gamble:RegisterEvent("ADDON_LOADED")
end

--Wait for load to finish then drawn frame/grab info
function Gamble_Event(self, event, ...)
	if event == "ADDON_LOADED" then
		local arg1 = ...
		if arg1 == "Gamble" then
			
			Gamble_LoadFrames()
			
			-- setup option frame tabs
			PanelTemplates_SetNumTabs(Gamble_Options_Frame, 3)
			PanelTemplates_SetTab(Gamble_Options_Frame, 1)
	
			if GAMBLE_JEOPARDY["dryspell"] == nil then
				GAMBLE_JEOPARDY["dryspell"] = 0
			end
			
			-- This updates party info and frames
			Gamble_PartyChange()
						
			if GAMBLE_SAVED_VARS["hidden"] then
				Gamble:Hide()
				GAMBLE_SAVED_VARS["hidden"] = true
			else
				Gamble:Show()
				GAMBLE_SAVED_VARS["hidden"] = false
			end
			
			if GAMBLE_SAVED_VARS["locked"] then
				GAMBLE_SAVED_VARS["locked"] = true
			else
				GAMBLE_SAVED_VARS["locked"] = false
			end
			
			Gamble_AnnounceFrame_OnEvent()				
			
			Gamble_StartButton_OnShow()
			Gamble_PauseButton_OnShow()

			RegisterAddonMessagePrefix("Gamble")
			
			Gamble:RegisterEvent("PARTY_MEMBERS_CHANGED")
			Gamble:RegisterEvent("CHAT_MSG_ADDON")
			
			
			--Gamble:RegisterEvent("COMPANION_UPDATE")																									-- this ones for testing alone.
			--GambleMessageParser_RegisterFunction("Gamble", LOOT_ITEM_SELF, Gamble_LootWon_Self, false)						-- this ones for testing alone.				"You receive loot: %s."
			
			GambleMessageParser_RegisterFunction("Gamble", LOOT_ROLL_YOU_WON, Gamble_LootWon_Self, false)				-- you won an item								"You won: %s"
			GambleMessageParser_RegisterFunction("Gamble", LOOT_ROLL_WON, Gamble_LootWon, false)								-- someone else won an item				"%s won: %s"
			GambleMessageParser_RegisterFunction("Gamble", LOOT_ROLL_PASSED_SELF, Gamble_LootSkipped_Self, false)	-- you passed on an item					"You passed on: %s"
			GambleMessageParser_RegisterFunction("Gamble", LOOT_ROLL_PASSED, Gamble_LootSkipped, false)					-- someone else passed on an item		"%s passed on: %s"
			
			--Gamble:RegisterEvent("CHAT_MSG_SYSTEM")																									-- for watching rolls
			--GambleMessageParser_RegisterFunction("Gamble", RANDOM_ROLL_RESULT, Gamble_RollResult, false)					-- a roll has been made						"%s rolls %d (%d-%d)"
			
			DEFAULT_CHAT_FRAME:AddMessage("Group Gamble Loaded.")
		end
	
	elseif event == "START_LOOT_ROLL" then
		local id, timer = ...
		Gamble_LootRoll_OnEvent(id)
		
	elseif event == "CHAT_MSG_LOOT" then
		local message = ...
		GambleMessageParser_ParseMessage("Gamble", message)
		
	elseif event == "CHAT_MSG_SYSTEM" then
		local message = ...
		GambleMessageParser_ParseMessage("Gamble", message)
		
	elseif event == "PARTY_MEMBERS_CHANGED" then
		Gamble_PartyChange()
		
	elseif event == "CHAT_MSG_SAY" or event == "CHAT_MSG_WHISPER" or event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_PARTY_LEADER" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" then
		local message, player = ...
		Gamble_TakeBets_OnEvent(message, player)
		
	elseif event == "COMPANION_UPDATE" then
		--Gamble_CompanionPet_OnEvent()
		
	elseif event == "CHAT_MSG_ADDON" then
		local prefix, message, channel, sender = ...
		--filter other addons, messages from you (even possible??) and other servers
		if prefix == "Gamble" and sender ~= UnitName("player") and UnitIsSameServer("player", sender) then
			Gamble_ModComm_Receive(message)
		end
	end
	
end

-- toggle the players play status
function Gamble_TogglePlaying_OnClick(name)
	if not GAMBLE_SAVED_VARS["client"] then
		if GAMBLE_SAVED_VARS["players"][name]["playing"] then
			GAMBLE_SAVED_VARS["players"][name]["playing"] = false
		else
			GAMBLE_SAVED_VARS["players"][name]["playing"] = true
		end
	end
	Gamble_UpdateFrames()
end

-- display the announcement frame if its enabled
function Gamble_AnnounceFrame_OnEvent()
	if GAMBLE_SAVED_VARS["announceframe"] then
		if GAMBLE_SAVED_VARS["gameinprogress"] then
			Gamble_Announcement_Board:Show()
		end
		GAMBLE_SAVED_VARS["announceframe"] = true
	else
		Gamble_Announcement_Board:Hide()
		GAMBLE_SAVED_VARS["announceframe"] = false
	end
end

-- show popup for gold won or lost and save stats if necessary
function Gamble_FinishGame(winner, wager, pot)
	if UnitName("player") == winner then
		--winner!
		StaticPopupDialogs["GambleGameOverPopup"] = {
		text = format(GAMBLE_POPUP_WINNER, GetCoinTextureString(pot - wager)),
		button1 = GAMBLE_TEXT_OK,
		OnAccept = function (self) end,
		OnCancel = function (self) end,
		hideOnEscape = 1,
		timeout = 0,
		}
		
	else
		--loser :(
		StaticPopupDialogs["GambleGameOverPopup"] = {
		text = format(GAMBLE_POPUP_LOSER, winner, GetCoinTextureString(Gamble_PlayerTotalStake(UnitName("player")))),
		button1 = GAMBLE_TEXT_OK,
		OnAccept = function (self) end,
		OnCancel = function (self) end,
		hideOnEscape = 1,
		timeout = 0,
		}
	end
	
	StaticPopup_Show("GambleGameOverPopup")
	
	if GAMBLE_SAVED_VARS["savestats"] then
		for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
			if k == winner then
				-- winner
				Gamble_SaveStats(k, v["items"], pot - Gamble_PlayerTotalStake(k), v["minroll"], v["playing"], true)
			else
				-- losers
				Gamble_SaveStats(k, v["items"], Gamble_PlayerTotalStake(k), v["minroll"], v["playing"], false)
			end
		end
		
		--update statistics frame if it was actually updated
		Gamble_StatFrame_Update()
	end
end

-- client game setup
function Gamble_Client_Startup()
	Gamble:UnregisterEvent("CHAT_MSG_LOOT")
	
	GAMBLE_SAVED_VARS["client"] = true
	GAMBLE_SAVED_VARS["gameinprogress"] = true
	
	_G["Gamble_StartButton"]:Disable()
	_G["Gamble_PauseButton"]:Disable()
	
	for i = 1, GAMBLE_PARTY_SIZE do
		_G["Gambler"..i.."_WinnerButton"]:Disable()
	end
end

-- update player with info received from host
function Gamble_Client_UpdatePlayer(player, items, wager, stake, stolen, itemroll, bonusroll, minroll, maxroll, playing)
	for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
		if k == player then
			v["items"] = tonumber(items)
			v["wager"] = tonumber(wager)
			v["stake"] = tonumber(stake)
			v["stolen"] = tonumber(stolen)
			v["itemroll"] = tonumber(itemroll)
			v["bonusroll"] = tonumber(bonusroll)
			v["minroll"] = tonumber(minroll)
			v["maxroll"] = tonumber(maxroll)
			if playing == "true" then
				v["playing"] = true
			else
				v["playing"] = false
			end
		end
	end
end

-- update the info frame with options settings if you're a host or outside a game.  use the hosts info given to you if you're a client
function Gamble_InfoWindow(point)
	ItemRefTooltip:SetOwner(point, "ANCHOR_PRESERVE")
	
	ItemRefTooltip:AddLine("Game Rules and Settings", 1, 1, 1, 1, true)
	
	if GAMBLE_SAVED_VARS["client"] then
		if GAMBLE_INFOFRAME["green"] then
			ItemRefTooltip:AddLine(" ", 1, 1, 1, 1, true)
			
			ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_UNCOMMON, GetCoinTextureString(GAMBLE_INFOFRAME["green"]), 1, 1, 1, 1, 1, 1)
			ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_RARE, GetCoinTextureString(GAMBLE_INFOFRAME["blue"]), 1, 1, 1, 1, 1, 1)
			ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_EPIC, GetCoinTextureString(GAMBLE_INFOFRAME["purple"]), 1, 1, 1, 1, 1, 1)
			ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_NONPLAYER, GetCoinTextureString(GAMBLE_INFOFRAME["nonplayer"]), 1, 1, 1, 1, 1, 1)
			
			ItemRefTooltip:AddLine(" ", 1, 1, 1, 1, true)
			
			ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_HIGHSTAKES, GAMBLE_INFOFRAME["highstakes"], 1, 1, 1, 1, 1, 1)
			ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_DOUBLEITEM, GAMBLE_INFOFRAME["doubleitem"], 1, 1, 1, 1, 1, 1)
			ItemRefTooltip:AddDoubleLine("Chaos Orb", GAMBLE_INFOFRAME["chaosorb"], 1, 1, 1, 1, 1, 1)
			ItemRefTooltip:AddDoubleLine("Skipped Items", GAMBLE_INFOFRAME["ignoreskips"], 1, 1, 1, 1, 1, 1)
		end
	else		
		ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_UNCOMMON, GetCoinTextureString(GAMBLE_DROP_VALUES["uncommon"]), 1, 1, 1, 1, 1, 1)
		ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_RARE, GetCoinTextureString(GAMBLE_DROP_VALUES["rare"]), 1, 1, 1, 1, 1, 1)
		ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_EPIC, GetCoinTextureString(GAMBLE_DROP_VALUES["epic"]), 1, 1, 1, 1, 1, 1)
		ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_NONPLAYER, GetCoinTextureString(GAMBLE_DROP_VALUES["nonplayer"]), 1, 1, 1, 1, 1, 1)
		
		ItemRefTooltip:AddLine(" ", 1, 1, 1, 1, true)
		
		ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_HIGHSTAKES, GAMBLE_CONSTANTS["jeopardychance"].."%", 1, 1, 1, 1, 1, 1)
		ItemRefTooltip:AddDoubleLine(GAMBLE_OPTIONSTEXT_DOUBLEITEM, GAMBLE_CONSTANTS["doubleitemchance"].."%", 1, 1, 1, 1, 1, 1)
		
		if GAMBLE_SAVED_VARS["usechaosorb"] then
			ItemRefTooltip:AddDoubleLine("Chaos Orb", "In play", 1, 1, 1, 1, 1, 1)
		else
			ItemRefTooltip:AddDoubleLine("Chaos Orb", "Ignored", 1, 1, 1, 1, 1, 1)
		end
		
		if GAMBLE_SAVED_VARS["ignoreskips"] then
			ItemRefTooltip:AddDoubleLine("Skipped Items", "Ignored", 1, 1, 1, 1, 1, 1)
		else
			ItemRefTooltip:AddDoubleLine("Skipped Items", "Charged", 1, 1, 1, 1, 1, 1)
		end
	end
	
	ItemRefTooltip:Show()
end

--When start is pressed, confirm that you want to begin
function Gamble_StartButton_OnClick()
	if GAMBLE_SAVED_VARS["gameinprogress"] then
		StaticPopup_Show("GambleAbandonConfirm")
	else
		StaticPopup_Show("GambleStartConfirm")
	end
end

--Start button is shown
function Gamble_StartButton_OnShow()
	if GAMBLE_SAVED_VARS["gameinprogress"] then
		_G["Gamble_StartButton"]:SetText("Abandon")
	else
		_G["Gamble_StartButton"]:SetText("Start")
	end
end

--Pause button is shown
function Gamble_PauseButton_OnShow()
	if GAMBLE_SAVED_VARS["gameinprogress"] then
		if GAMBLE_SAVED_VARS["client"] then
			_G["Gamble_PauseButton"]:Disable()
		else
			_G["Gamble_PauseButton"]:Enable()
		end
	else
		_G["Gamble_PauseButton"]:Disable()
	end
end

--Start game.  Reset values, find players names and get initial pot and round going.
function Gamble_Start()
	--Wipe pot
	GAMBLE_POT = 0
	
	-- Wipe the slate clean
	for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
		v["items"] = 0
		v["stake"] = 0
		v["stolen"] = 0
		
		v["itemroll"] = 0
		v["bonusroll"] = 0
	end
	
	--Is it time for a jeopardy round?!?!?!
	local lowerThanThis = GAMBLE_CONSTANTS["jeopardychance"]
	if GAMBLE_JEOPARDY["dryspell"] >= GAMBLE_CONSTANTS["dryspelltime"] then
		lowerThanThis = lowerThanThis * 5	--sets the bar to beat at 5x the normal 1*5=5%, 20*5=100%
	end
	
	if math.random(1, 100) <= lowerThanThis then
		GAMBLE_JEOPARDY["streak"] = GAMBLE_JEOPARDY["streak"] + 1
		GAMBLE_CONSTANTS["multiplier"] = GAMBLE_CONSTANTS["base"] ^ GAMBLE_JEOPARDY["streak"]		
		GAMBLE_JEOPARDY["dryspell"] = 0
		
		Gamble_ChatComm(GAMBLE_CHAT_BEGIN2, "YELL")
		
		local streakchoice = math.random(1, 8)
		local mult = GAMBLE_CONSTANTS["multiplier"]
		
		if streakchoice <= 4 then
			GAMBLE_JEOPARDY["streaktype"] = "normal"
			Gamble_ChatComm(GAMBLE_CHAT_STAKES, "YELL", mult)
			Gamble_Announce(GAMBLE_CHAT_BEGIN2.."\r"..format(GAMBLE_CHAT_STAKES, mult), 5)
			
		elseif streakchoice == 5 then
			GAMBLE_JEOPARDY["streaktype"] = "green"
			Gamble_ChatComm(GAMBLE_CHAT_GREENSTAKES, "YELL", mult)
			Gamble_Announce(GAMBLE_CHAT_BEGIN2.."\r"..format(GAMBLE_CHAT_GREENSTAKES, mult), 6)
			
		elseif streakchoice == 6 then
			GAMBLE_JEOPARDY["streaktype"] = "blue"
			Gamble_ChatComm(GAMBLE_CHAT_BLUESTAKES, "YELL", mult)
			Gamble_Announce(GAMBLE_CHAT_BEGIN2.."\r"..format(GAMBLE_CHAT_BLUESTAKES, mult), 7)
			
		elseif streakchoice == 7 then
			GAMBLE_JEOPARDY["streaktype"] = "purple"
			Gamble_ChatComm(GAMBLE_CHAT_PURPLESTAKES, "YELL", mult)
			Gamble_Announce(GAMBLE_CHAT_BEGIN2.."\r"..format(GAMBLE_CHAT_PURPLESTAKES, mult), 8)
			
		else	-- 8 and other magic possibilities
			GAMBLE_JEOPARDY["streaktype"] = "nonplayer"
			Gamble_ChatComm(GAMBLE_CHAT_NONPLAYERSTAKES, "YELL", mult)
			Gamble_Announce(GAMBLE_CHAT_BEGIN2.."\r"..format(GAMBLE_CHAT_NONPLAYERSTAKES, mult), 4)
		end
		
	else
		GAMBLE_JEOPARDY["streak"] = 0
		GAMBLE_CONSTANTS["multiplier"] = 1		
		GAMBLE_JEOPARDY["dryspell"] = GAMBLE_JEOPARDY["dryspell"] + 1
		
		Gamble_Announce(GAMBLE_CHAT_BEGIN, 1)
		Gamble_ChatComm(GAMBLE_CHAT_BEGIN, "YELL")
	end
	
	for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
		if v["playing"] then
			--v["minroll"] = (v["wager"] / 10000) / 2		-- Take initial bid, convert to useable number and divide by 2 to find bonus roll.
			if GAMBLE_STATS[Gamble_GetFullName(k)] ~= nil  and GAMBLE_SAVED_VARS["savestats"] then
				if GAMBLE_STATS[Gamble_GetFullName(k)]["losestreak"] >= 5 then
					v["maxroll"] = GAMBLE_CONSTANTS["upperlimit"] + ((GAMBLE_STATS[Gamble_GetFullName(k)]["losestreak"] - 4) * 5)
				else
					v["maxroll"] = GAMBLE_CONSTANTS["upperlimit"]
				end
			else
				v["maxroll"] = GAMBLE_CONSTANTS["upperlimit"]
			end
		end
	end

	Gamble:RegisterEvent("CHAT_MSG_LOOT")			-- watch chat for loot drops
	Gamble:RegisterEvent("START_LOOT_ROLL")		-- watch for loot windows
	_G["Gamble_PauseButton"]:SetText(GAMBLE_TEXT_PAUSE)
	_G["Gamble_PauseButton"]:Enable()
	
	Gamble_Update_Rules()
	Gamble_UpdateFrames()
	Gamble_ChatComm(GAMBLE_CHAT_POT, "PARTY", GetCoinText(GAMBLE_POT))
end

-- the game has been stopped so reset stuff
function Gamble_TerminateGame()
	-- start watching communication again for future games (I dont think I even turned this off)
	Gamble:RegisterEvent("CHAT_MSG_ADDON")

	-- stop watching chat and loot
	Gamble:UnregisterEvent("CHAT_MSG_LOOT")
	Gamble:UnregisterEvent("START_LOOT_ROLL")
	
	Gamble:UnregisterEvent("CHAT_MSG_SAY")
	Gamble:UnregisterEvent("CHAT_MSG_WHISPER")
	Gamble:UnregisterEvent("CHAT_MSG_PARTY")
	Gamble:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
	Gamble:UnregisterEvent("CHAT_MSG_RAID")
	Gamble:UnregisterEvent("CHAT_MSG_RAID_LEADER")
	
	-- post it
	--Gamble_Announcement_Board_TextBox:AddMessage(GAMBLE_CHAT_STOP, 1, 0, 0, 2)
	
	-- you obviously arent playing a game now
	GAMBLE_SAVED_VARS["gameinprogress"] = false
	
	-- you are no longer a client if you were at all
	GAMBLE_SAVED_VARS["client"] = false
	
	-- start button is good to go, pause is reset
	_G["Gamble_PauseButton"]:Disable()
	_G["Gamble_StartButton"]:Enable()
	_G["Gamble_PauseButton"]:SetText(GAMBLE_TEXT_RESUME)
	_G["Gamble_StartButton"]:SetText(GAMBLE_TEXT_START)
	
	--reset streak
	GAMBLE_JEOPARDY["streaktype"] = "none"
	
	--reset kill timer and box so that it doesnt fade prematurely
	GAMBLE_ANNOUNCE_THROTTLE = 0
	Gamble_Announcement_Board:SetAlpha(1)

	--reset the bg color from any high stakes rounds
	Gamble:SetBackdropColor(0, 0, 0, 0.6)
	
	-- make sure buttons are reenabled for future use
	for i = 1, GAMBLE_PARTY_SIZE do
		_G["Gambler"..i.."_WinnerButton"]:Enable()
	end	
end

--If you skipped hook this in and put your name into function var
function Gamble_LootSkipped_Self(itemText)
	Gamble_LootSkipped(UnitName("player"), itemText)
end

--Punish someone if they intentially skip rolling on loot
function Gamble_LootSkipped(player, itemText)
	local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemText)
	Gamble_LootWon(player, itemText, true)
end

--If you win hook this in and put your name into function var
function Gamble_LootWon_Self(itemText)
	Gamble_LootWon(UnitName("player"), itemText, false)
end

--Award player with roll increase and put gold in the pot
function Gamble_LootWon(player, itemText, itemStolen)
	-- setup info
	local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemText)
	local cost, value, multiplier, doubleItem = 0, 0, 1, false
	
	-- skip everything if it was a chaos orb and was toggled off
	if quality == 2 and GAMBLE_DROP_VALUES["uncommon"] == 0 then
		--ignore it because it's value is 0
		
	elseif quality == 3 and GAMBLE_DROP_VALUES["rare"] == 0	then
		--ignore it because it's value is 0
		
	elseif quality == 4 and GAMBLE_DROP_VALUES["epic"] == 0 then
		--ignore it because it's value is 0
		
	elseif not GAMBLE_SAVED_VARS["usechaosorb"] and name == "Chaos Orb" then
		--ignore it because it was a Chaos Orb
		
	elseif GAMBLE_SAVED_VARS["ignoreskips"] and itemStolen then
		-- the item was skipped but we aren't penalizing that today
		
	else
		-- was it passed on by the "winner"?
		if not itemStolen then
			itemStolen = false
		end
		
		-- was it a double item???
		if math.random(1, 100) <= GAMBLE_CONSTANTS["doubleitemchance"] then
			multiplier = multiplier * GAMBLE_CONSTANTS["doubleitem"]
			doubleItem = true
			Gamble_ChatComm(GAMBLE_CHAT_DOUBLEITEM, "PARTY", link)
		end
		
		-- apply normal streak multiplier?
		if GAMBLE_JEOPARDY["streaktype"] == "normal" then
			multiplier = multiplier * GAMBLE_CONSTANTS["multiplier"]
		end
		
		if quality == 2 then
			-- apply green streak multiplier?
			if GAMBLE_JEOPARDY["streaktype"] == "green" then
				multiplier = multiplier * GAMBLE_CONSTANTS["multiplier"]
			end
			value = GAMBLE_DROP_VALUES["uncommon"]
			
		elseif quality == 3 then
			-- apply blue streak multiplier?
			if GAMBLE_JEOPARDY["streaktype"] == "blue" then
				multiplier = multiplier * GAMBLE_CONSTANTS["multiplier"]
			end
			value = GAMBLE_DROP_VALUES["rare"]
			
		elseif quality == 4 then
			-- apply purple streak multiplier?
			if GAMBLE_JEOPARDY["streaktype"] == "purple" then
				multiplier = multiplier * GAMBLE_CONSTANTS["multiplier"]
			end
			value = GAMBLE_DROP_VALUES["epic"]
		end
		
		
		local v = GAMBLE_SAVED_VARS["players"][player]
		-- was the winner a participant?
		if v["playing"] then
			-- yes they were
			
			cost = value * multiplier
			
			if itemStolen then
				-- they intentionally skipped out on this item
				v["stolen"] = v["stolen"] + cost
				Gamble_ChatComm(GAMBLE_CHAT_SKIP, "PARTY", player, link, GetCoinText(cost))
				if doubleItem then
					Gamble_Announce(GAMBLE_CHAT_SKIPDOUBLE, 4, player, link, GetCoinTextureString(cost), GetCoinTextureString(cost / 2))
				else
					Gamble_Announce(GAMBLE_CHAT_SKIP, 3, player, link, GetCoinTextureString(cost))
				end
			else
				-- won normally
				--v["minroll"] = v["minroll"] + GAMBLE_CONSTANTS["rolladdition"]
				
				-- was it an orb?
				if name == "Frozen Orb" or name == "Chaos Orb" then
					-- yes
					v["bonusroll"] = v["bonusroll"] + 5
					
					if doubleItem then
						-- add an extra 5 for it being a double orb
						v["bonusroll"] = v["bonusroll"] + 5
						Gamble_ChatComm(GAMBLE_CHAT_DOUBLEORB, "PARTY", player)
						Gamble_Announce(GAMBLE_ANNOUNCE_DOUBLEORB, 4, player, link)
					else
						Gamble_ChatComm(GAMBLE_CHAT_ORB, "PARTY", player, link)
						Gamble_Announce(GAMBLE_CHAT_ORB, 3, player, link)
					end
				else
					-- no
					v["items"] = v["items"] + 1
					v["stake"] = v["stake"] + cost
										
					Gamble_ChatComm(GAMBLE_CHAT_WAGER, "PARTY", player, GetCoinText(cost), player, GetCoinText(Gamble_PlayerTotalStake(player)))
					if doubleItem then
						Gamble_Announce(GAMBLE_ANNOUNCE_DOUBLEITEM, 4, player, link, GetCoinTextureString(cost), GetCoinTextureString(cost / 2))	
					else
						Gamble_Announce(GAMBLE_ANNOUNCE_PLAYERWON, 3, player, link, GetCoinTextureString(cost))
					end
				end
			end
		else
			-- no they werent				
			if itemStolen then
				-- they skipped out on this item but arent playing anyway
			else
				-- won normally
				v["items"] = v["items"] + 1
				
				if GAMBLE_JEOPARDY["streaktype"] == "nonplayer" then
				multiplier = multiplier * GAMBLE_CONSTANTS["multiplier"]
				end				
				cost = GAMBLE_DROP_VALUES["nonplayer"] * multiplier
				
				Gamble_ChatComm(GAMBLE_CHAT_NONPLAYER, "PARTY", player, GetCoinText(cost))
				if doubleItem then
					Gamble_Announce(GAMBLE_ANNOUNCE_DOUBLENONPLAYERWON, 4, GetCoinTextureString(cost), GetCoinTextureString(cost / 2))
				else
					Gamble_Announce(GAMBLE_ANNOUNCE_NONPLAYERWON, 3, GetCoinTextureString(cost))
				end
				
				-- apply cost to all people playing
				for k2, v2 in pairs(GAMBLE_SAVED_VARS["players"]) do
					if v2["playing"] then
						v2["stake"] = v2["stake"] + cost
					end
				end
			end
		end

		-- update frame
		Gamble_UpdateFrames()
		Gamble_ChatComm(GAMBLE_CHAT_POT, "PARTY", GetCoinText(GAMBLE_POT))
	end
end

--Remove any missing players and update display with proper names and maintain accurate info
function Gamble_PartyChange()
	for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
		if UnitInParty(k) or UnitInRaid(k) then
			-- do nothing
		else
			GAMBLE_SAVED_VARS["players"][k] = nil
		end
	end
	
	if GetRealNumPartyMembers() == 0 and GetRealNumRaidMembers() == 0 then
		-- if you're a host and leave the party/DC you don't want your game info reset and lost. you can do that manually if you must.
		if GAMBLE_SAVED_VARS["client"] then
			Gamble_TerminateGame()
		end
		--hide the announcement board regardless of whether you want it shown or not
		Gamble_Announcement_Board:Hide()
		
		if GAMBLE_SAVED_VARS["framehide"] then
			Gamble_ToggleVisible(true)
		end
	end
	Gamble_UpdateFrames()
end


-- place player info into the available frame
function Gamble_PlayerFrame_UpdateFrame(i)
	local name
	
	if GetRealNumPartyMembers() > 0  and GetRealNumRaidMembers() <= 0 then
		-- its a party only
		if i == GAMBLE_PARTY_SIZE then
			name = UnitName("player")
		else
			name = UnitName("party"..i)
		end			
	elseif GetRealNumRaidMembers() > 0 then
		-- its a raid
		name = UnitName("raid"..i)
	else
		-- its a lone player
		name = UnitName("player")
	end

	Gamble_AnnounceFrame_OnEvent()
	
	--update the frame with info
	if name then
		local v = GAMBLE_SAVED_VARS["players"][name]
		local class, classFileName = UnitClass(name)
		local color = RAID_CLASS_COLORS[classFileName]
		_G["Gambler"..i.."_PlayerName"]:SetText(name)
		if color then
			_G["Gambler"..i.."_PlayerName"]:SetTextColor(color.r, color.g, color.b)
		end
		_G["Gambler"..i.."_TogglePlayer"]:SetScript("OnClick", function() Gamble_TogglePlaying_OnClick(name) end)
		_G["Gambler"..i.."_WinnerButton"]:SetScript("OnClick", function() Gamble_Payout_OnClick(name) end)

		_G["Gambler"..i.."_Wager"]:SetText(GetCoinTextureString(Gamble_PlayerTotalStake(name)))
		_G["Gambler"..i.."_ItemsWon"]:SetText(v["items"])
		
		if v["playing"] then
			_G["Gambler"..i.."_RollButton"]:SetScript("OnEnter", function(self) Gamble_Helpful_Infotip_OnEnter(self, name, "roll") end)
			_G["Gambler"..i.."_RollButton"]:SetScript("OnLeave", function() Gamble_Helpful_Tooltip_OnLeave() end)
			_G["Gambler"..i.."_WagerButton"]:SetScript("OnEnter", function(self) Gamble_Helpful_Infotip_OnEnter(self, name, "gold") end)
			_G["Gambler"..i.."_WagerButton"]:SetScript("OnLeave", function() Gamble_Helpful_Tooltip_OnLeave() end)
		else
			_G["Gambler"..i.."_RollButton"]:SetScript("OnEnter", function(self) end)
			_G["Gambler"..i.."_RollButton"]:SetScript("OnLeave", function() end)
			_G["Gambler"..i.."_WagerButton"]:SetScript("OnEnter", function(self) end)
			_G["Gambler"..i.."_WagerButton"]:SetScript("OnLeave", function() end)
		end
		
		if v["playing"] then
			Gamble_PlayerMinRoll(name)
			
			if v["minroll"] > 0 then
				if v["minroll"] <= v["maxroll"] then
					_G["Gambler"..i.."_Roll"]:SetText(v["minroll"].."-"..v["maxroll"])
				else
					_G["Gambler"..i.."_Roll"]:SetText(v["maxroll"].."-"..v["minroll"])
				end
			else
				_G["Gambler"..i.."_Roll"]:SetText("1-"..v["maxroll"])
			end
		else
			_G["Gambler"..i.."_Roll"]:SetText("N/A")
		end
		
		--Send info to client mod
		local message = name.."\a"..v["items"].."\a"..v["wager"].."\a"..v["stake"].."\a"..v["stolen"].."\a"..v["itemroll"].."\a"..v["bonusroll"].."\a"..v["minroll"].."\a"..v["maxroll"].."\a"..tostring(v["playing"])
		Gamble_ModComm_Send("player_update\a"..message)
					
		_G["Gambler"..i]:Show()
		
		if UnitIsSameServer("player", name) then
			_G["Gambler"..i.."_TogglePlayer"]:Enable()
			_G["Gambler"..i.."_TogglePlayer"]:Show()
			if v["playing"] then
				_G["Gambler"..i.."_TogglePlayer"]:SetChecked(true)
				_G["Gambler"..i.."_WinnerButton"]:Enable()
			else
				_G["Gambler"..i.."_TogglePlayer"]:SetChecked(false)
				_G["Gambler"..i.."_WinnerButton"]:Disable()
			end
		else
			_G["Gambler"..i.."_TogglePlayer"]:SetChecked(false)
			_G["Gambler"..i.."_TogglePlayer"]:Disable()
			_G["Gambler"..i.."_TogglePlayer"]:Hide()
			_G["Gambler"..i.."_WinnerButton"]:Disable()
		end
		
		Gamble:SetHeight(70 + (GAMBLE_PARTY_SIZE * 20))
	end
end

-- Update game stats variables
function Gamble_GameInfo_UpdateVars()
	GAMBLE_POT = 0
	GAMBLE_CONSTANTS["multiplier"] = GAMBLE_CONSTANTS["base"] ^ GAMBLE_JEOPARDY["streak"]
	
	for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
		if v["playing"] then
			GAMBLE_POT = GAMBLE_POT + Gamble_PlayerTotalStake(k)
		end
	end
	
	return GAMBLE_POT
end

-- Update the frame with the up to date game stats
function Gamble_GameInfo_UpdateFrame()
	local message = GAMBLE_CONSTANTS["base"].."\a"..GAMBLE_JEOPARDY["dryspell"].."\a"..GAMBLE_JEOPARDY["streak"].."\a"..GAMBLE_JEOPARDY["streaktype"]
	Gamble_ModComm_Send("info_update\a"..message) --base, dryspell, streak, streaktype
	
	if GAMBLE_JEOPARDY["streak"] >= 1 then
		if GAMBLE_JEOPARDY["streaktype"] == "green" then
			_G["Gambler_Multiplier"]:SetText("Mult: |cFF1EFF00x"..GAMBLE_CONSTANTS["multiplier"].."|r")
			Gamble:SetBackdropColor(0.3, 0.7, 0, 0.6)
		elseif GAMBLE_JEOPARDY["streaktype"] == "blue" then
			_G["Gambler_Multiplier"]:SetText("Mult: |cFF0080FFx"..GAMBLE_CONSTANTS["multiplier"].."|r")
			Gamble:SetBackdropColor(0, 0.5, 1, 0.6)
		elseif GAMBLE_JEOPARDY["streaktype"] == "purple" then
			_G["Gambler_Multiplier"]:SetText("Mult: |cFFB048F8x"..GAMBLE_CONSTANTS["multiplier"].."|r")
			Gamble:SetBackdropColor(0.7, 0.3, 0.95, 0.6)
		elseif GAMBLE_JEOPARDY["streaktype"] == "nonplayer" then
			_G["Gambler_Multiplier"]:SetText("Mult: |cFFFF0000x"..GAMBLE_CONSTANTS["multiplier"].."|r")
			Gamble:SetBackdropColor(0.8, 0, 0, 0.6)
		elseif GAMBLE_JEOPARDY["streaktype"] == "normal" then
			_G["Gambler_Multiplier"]:SetText("Mult: |cFFE67512x"..GAMBLE_CONSTANTS["multiplier"].."|r")
			Gamble:SetBackdropColor(0.95, 0.45, 0.15, 0.6)
		else	-- regular round
			_G["Gambler_Multiplier"]:SetText("Mult: |cFFFFFFFFx"..GAMBLE_CONSTANTS["multiplier"])
			Gamble:SetBackdropColor(0, 0, 0, 0.6)
		end
	else
		_G["Gambler_Multiplier"]:SetText("Mult: |cFFFFFFFFx"..GAMBLE_CONSTANTS["multiplier"])
		--Gamble:SetBackdropColor(0, 0, 0, 0.6)
	end
	
	_G["Gambler_DrySpell"]:SetText("Reg Games: |cFFFFFFFF"..GAMBLE_JEOPARDY["dryspell"].."|r")
	_G["Gambler_Pot"]:SetText("Pot: |cFFFFFFFF"..GetCoinTextureString(GAMBLE_POT).."|r")
end


--Update variables per player
function Gamble_PlayerFrame_UpdateVars(player)
	if not GAMBLE_SAVED_VARS["players"][player] then
		GAMBLE_SAVED_VARS["players"][player] = {}
	end
	
	local v = GAMBLE_SAVED_VARS["players"][player]
		
	if not v["items"] then
		v["items"] = 0
	end
	
	if not v["wager"] then
		v["wager"] = 0
	end
	
	if not v["stake"] then
		v["stake"] = 0
	end
	
	if not v["stolen"] then
		v["stolen"] = 0
	end
	
	if not v["itemroll"] then
		v["itemroll"] = 0
	end
	
	if not v["bonusroll"] then
		v["bonusroll"] = 0
	end
	
	if not v["minroll"] then
		v["minroll"] = 0
	end
	
	if not v["maxroll"] then
		v["maxroll"] = 100
	end
	
	if not v["playing"] then
		v["playing"] = false
	end
end

--Pause or resume play depending on current state of loot watching
function Gamble_PausePlay()
	if Gamble:IsEventRegistered("CHAT_MSG_LOOT") then
		Gamble:UnregisterEvent("CHAT_MSG_LOOT")
		Gamble:UnregisterEvent("START_LOOT_ROLL")
		DEFAULT_CHAT_FRAME:AddMessage(GAMBLE_TEXT_ROUNDPAUSE)
		_G["Gamble_PauseButton"]:SetText(GAMBLE_TEXT_RESUME)
	else
		Gamble:RegisterEvent("CHAT_MSG_LOOT")
		Gamble:RegisterEvent("START_LOOT_ROLL")
		DEFAULT_CHAT_FRAME:AddMessage(GAMBLE_TEXT_ROUNDRESUME)
		_G["Gamble_PauseButton"]:SetText(GAMBLE_TEXT_PAUSE)
		Gamble_UpdateFrames()
	end
end

--a popup to handle initial wagers if you choose
function Gamble_TakeBet_Popup(minbet, maxbet)
	-- setup the correct min and max for slider
	local minbet, maxbet = tonumber(minbet), tonumber(maxbet)
	Gamble_BetPopup_YourBidValue:SetMinMaxValues(minbet, maxbet)
	
	_G[Gamble_BetPopup_YourBidValue:GetName().."High"]:SetText(GetCoinTextureString(maxbet))
	_G[Gamble_BetPopup_YourBidValue:GetName().."Low"]:SetText(GetCoinTextureString(minbet))
	
	Gamble_BetPopup_YourBidValue:SetValue(minbet)
	Gamble_BetPopup:Show()
end

--When the round begins, take everyone's wager
function Gamble_TakeBets()
	GAMBLE_SAVED_VARS["gameinprogress"] = true
	GAMBLE_SAVED_VARS["client"] = false
	for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
		if k == UnitName("player") then
			v["wager"] = GAMBLE_SAVED_VARS["bet"]
		else
			v["wager"] = 0
			if v["playing"] then
				Gamble_ModComm_Send("game_start\a"..GAMBLE_DROP_VALUES["minbid"].."\a"..GAMBLE_DROP_VALUES["maxbid"], "WHISPER", k)
			end
		end	
	end
	
	Gamble_ChatComm(GAMBLE_CHAT_TAKEBETS, "PARTY", UnitName("player"), GetCoinText(GAMBLE_DROP_VALUES["minbid"]), GetCoinText(GAMBLE_DROP_VALUES["maxbid"]))
	
	--Cant be registering loot quite yet
	--Gamble:UnregisterEvent("CHAT_MSG_LOOT")
	
	_G["Gamble_PauseButton"]:Disable()
	_G["Gamble_PauseButton"]:SetText(GAMBLE_TEXT_RESUME)
	_G["Gamble_StartButton"]:SetText("Abandon")
	
	Gamble:RegisterEvent("CHAT_MSG_SAY")
	Gamble:RegisterEvent("CHAT_MSG_WHISPER")
	Gamble:RegisterEvent("CHAT_MSG_PARTY")
	Gamble:RegisterEvent("CHAT_MSG_PARTY_LEADER")
	Gamble:RegisterEvent("CHAT_MSG_RAID")
	Gamble:RegisterEvent("CHAT_MSG_RAID_LEADER")
end

-- rounding function
function round(num, idp)
	local mult = 10^(math.abs(idp) or 0)
	return math.floor(num * mult + 0.5) / mult
end

-- update the announcement frame with info and send the text to clients
function Gamble_Announce(message, id, ...)
	local text = format(message, ...)
	Gamble_Announcement_Board_TextBox:AddMessage(text, 1, 1, 1, id)
	Gamble_Announce_ColorText(Gamble_Announcement_Board_TextBox)
	
	Gamble_ModComm_Send("board_update\a"..text.."\a"..id)
end

-- color all the announcements nicely
function Gamble_Announce_ColorText(frame)
	frame:UpdateColorByID(1, 0, 0.8, 0)	-- start, green
	frame:UpdateColorByID(2, 1, 1, 1)		-- end, white
	frame:UpdateColorByID(3, 1, 1, 1)		-- reg loot, white
	frame:UpdateColorByID(4, 1, 0, 0)		-- doubled loot, nonplay HS, red
	frame:UpdateColorByID(5, 0.9, 0.46, 0.07)		-- reg HS, orange
	frame:UpdateColorByID(6, 0.12, 1, 0)		-- green HS, green
	frame:UpdateColorByID(7, 0, 0.5, 1)		-- blue HS, blue
	frame:UpdateColorByID(8, 0.69, 0.29, 0.97)		-- purple HS, purple
end

--send the selected bid
function Gamble_SendWager_OnClick()
	Gamble_BetPopup:Hide()
	local player, wager = UnitName("player"), Gamble_BetPopup_YourBidValue:GetValue() / 10000
	Gamble_ModComm_Send("send_wager\a"..player.."\a"..wager)
end

-- take bet from player 
function Gamble_TakeBets_OnEvent(message, player)
	local wager = tonumber(message)
	if type(tonumber(wager)) == "number" then
	wager = wager * 10000
		for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
			if k == player and v["playing"] and v["wager"] == 0 then
				if wager >= GAMBLE_DROP_VALUES["minbid"] and wager <= GAMBLE_DROP_VALUES["maxbid"] and (wager / 10000) % 10 == 0 then
					-- Wager accepted
					v["wager"] = wager
					SendChatMessage(format(GAMBLE_CHAT_WAGERACCEPTED, GetCoinText(v["wager"])), "WHISPER", nil, player)
					Gamble_ModComm_Send("confirm_wager\a", "WHISPER", player)
				else
					-- Wager declined
					SendChatMessage(GAMBLE_CHAT_WAGERDECLINED, "WHISPER", nil, player)
					v["wager"] = 0
				end
			end
		end
	end
	
	--Perform ready check to see if everyone has made their wager
	local ready = true
	for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
		if v["playing"] and v["wager"] == 0 then
			ready = false
		end
	end
	
	--Get this shit going!
	if ready then
		Gamble:UnregisterEvent("CHAT_MSG_SAY")
		Gamble:UnregisterEvent("CHAT_MSG_WHISPER")
		Gamble:UnregisterEvent("CHAT_MSG_PARTY")
		Gamble:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
		Gamble:UnregisterEvent("CHAT_MSG_RAID")
		Gamble:UnregisterEvent("CHAT_MSG_RAID_LEADER")
		Gamble_ChatComm(GAMBLE_CHAT_WAGERSCOLLECTED, "PARTY")
		Gamble_Start()
	end
end

-- are you sure this is the winner?
function Gamble_Payout_OnClick(player)
	if GAMBLE_SAVED_VARS["gameinprogress"] and not GAMBLE_SAVED_VARS["client"] then
		StaticPopupDialogs["GambleWinnerConfirm"] = {
		text = format(GAMBLE_POPUP_WINNERCHECK, player),
		button1 = YES,
		button2 = NO,
		OnAccept = function (self) Gamble_Payout(player) end,
		OnCancel = function (self) end,
		hideOnEscape = 1,
		timeout = 0,
		}
		StaticPopup_Show("GambleWinnerConfirm")
	end
end

--Show winners name and payout from each player. save statistics as well
function Gamble_Payout(player)
	local winnersGold = Gamble_PlayerTotalStake(player)
	if GAMBLE_SAVED_VARS["players"][player]["playing"] then	
		-- popup with gold won or owed, save stats if necessary
		Gamble_FinishGame(player, winnersGold, GAMBLE_POT)
	
		-- post winner to chat and announcement frame
		Gamble_ChatComm(GAMBLE_CHAT_PAYOUT, "PARTY", player, GetCoinText(GAMBLE_POT - winnersGold))
		Gamble_Announce(GAMBLE_CHAT_PAYOUT, 2, player, GetCoinTextureString(GAMBLE_POT - winnersGold))
		
		-- post losers gold owed to chat
		for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
			if v["playing"] then 
				if k ~= player then
					Gamble_ChatComm(GAMBLE_CHAT_PAYERS, "PARTY", k, Gamble_PlayerTotalStake(k))
				end
			end
		end
		
		-- let others know game is over
		if not GAMBLE_SAVED_VARS["client"] then
			Gamble_ModComm_Send("game_complete\a"..player.."\a"..winnersGold.."\a"..GAMBLE_POT, "PARTY")
		end
		
		-- game is over, stop watching loot, reset stuff
		-- post it
		Gamble_Announcement_Board_TextBox:AddMessage(GAMBLE_CHAT_STOP, 1, 0, 0, 2)
		Gamble_TerminateGame()
	end
end

-- make a roll based on your current min and max
function Gamble_Rolls()
	local name = UnitName("player")
	local minroll, maxroll = GAMBLE_SAVED_VARS["players"][name]["minroll"], GAMBLE_SAVED_VARS["players"][name]["maxroll"]
	
	if minroll <= 0 then
		minroll = 1
	end
	
	if minroll <= maxroll then
		RandomRoll(minroll, maxroll)
	else
		RandomRoll(maxroll, minroll)
	end
end

-- apply bonus roll to a random player when a loot window opens if it has been at least minute since the last bonus
function Gamble_LootRoll_OnEvent(id)
	if GAMBLE_SAVED_VARS["gameinprogress"] and GAMBLE_SAVED_VARS["bossbonusroll"] then
		if GetTime() - GAMBLE_BOSSKILL_THROTTLE >= 60 then
			local texture, name, count, quality, bindOnPickUp, canNeed, canGreed, canDisenchant = GetLootRollItemInfo(id)
			
			if quality == 3 or quality == 4 then
				GAMBLE_BOSSKILL_THROTTLE = GetTime()
				
				local playerList, winner = {}, nil
				for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
					if v["playing"] then
						playerList[#playerList + 1] = k
					end
				end
				
				winner = playerList[math.random(1, #playerList)]
				
				if winner then
					GAMBLE_SAVED_VARS["players"][winner]["bonusroll"] = GAMBLE_SAVED_VARS["players"][winner]["bonusroll"] + 1
					Gamble_Announce(GAMBLE_ANNOUNCE_BONUSROLL, 1, winner)
					Gamble_UpdateFrames()
				end
			end
		end
	end
end

-- update and display tooltip
function Gamble_Helpful_Tooltip_OnEnter(point, text)
	if text then
		GameTooltip:SetOwner(point, "ANCHOR_LEFT")
		GameTooltip:SetText(text, 1, 1, 1, 1, true)
		GameTooltip:Show()
	end
end

-- update and display tooltip with game info
function Gamble_Helpful_Infotip_OnEnter(point, player, info)
	local var = GAMBLE_SAVED_VARS["players"][player]
	if var then
		GameTooltip:SetOwner(point, "ANCHOR_LEFT")
		if info == "gold" then
			GameTooltip:AddDoubleLine("Wager", GetCoinTextureString(var["wager"]), 1, 1, 1, 1, 1, 1)
			GameTooltip:AddDoubleLine("Contribution", GetCoinTextureString(var["stake"]), 1, 1, 1, 1, 1, 1)
			GameTooltip:AddDoubleLine("Penalties", GetCoinTextureString(var["stolen"]), 1, 1, 1, 1, 1, 1)
			GameTooltip:AddLine(" ", 1, 1, 1, 1, true)
			GameTooltip:AddDoubleLine("Total", GetCoinTextureString(Gamble_PlayerTotalStake(player)), 1, 1, 1, 1, 1, 1)
		else
			GameTooltip:AddDoubleLine("Wager", Gamble_PlayerWagerRoll(var["wager"]), 1, 1, 1, 1, 1, 1)
			GameTooltip:AddDoubleLine("Items", var["itemroll"], 1, 1, 1, 1, 1, 1)
			GameTooltip:AddDoubleLine("Bonus", var["bonusroll"], 1, 1, 1, 1, 1, 1)
			GameTooltip:AddLine(" ", 1, 1, 1, 1, true)
			GameTooltip:AddDoubleLine("Total", var["minroll"], 1, 1, 1, 1, 1, 1)
		end
		GameTooltip:Show()
	end
end

-- hide the tooltip
function Gamble_Helpful_Tooltip_OnLeave()
	GameTooltip:Hide()
end

-- return the full "name - server" string, name and realm of the player in 3 variables
function Gamble_GetFullName(player)
	local name, realm = UnitName(player)
	if not realm then
		realm = GetRealmName()
	end
	
	if name and realm then
		local fullname = name.." - "..realm
		return fullname, name, realm
	else
		return false
	end
end

-- determine the players minimum roll based off total items rolled on and how many they have won plus any bonuses
function Gamble_PlayerMinRoll(player)
	local var = GAMBLE_SAVED_VARS["players"][player]
	local totalItems = 0
	
	if var then
		-- get total item count
		for k, v in pairs(GAMBLE_SAVED_VARS["players"]) do
			if v["playing"] then
				totalItems = totalItems + v["items"]
			end
		end
		
		if totalItems <= 0 then
			totalItems = 1
		end
		
		-- their percentage of the total roll designated for items won. the more items won, the less they are worth in terms of +roll
		var["itemroll"] = math.ceil( (var["items"] / totalItems) * 50 )
		if not var["itemroll"] then
			var["itemroll"] = 0
		end
		
		var["minroll"] = var["itemroll"] + var["bonusroll"] + Gamble_PlayerWagerRoll(var["wager"])
		if not var["minroll"] then
			var["minroll"] = 0
		end
	end
end

-- return the total gold the player has at stake
function Gamble_PlayerTotalStake(player)
	local var = GAMBLE_SAVED_VARS["players"][player]
	
	if var then
		return var["stake"] + var["wager"] + var["stolen"]
	end
end

-- return the roll that the player purchased with their initial wager
function Gamble_PlayerWagerRoll(wager)
	return (wager / 10000) / 2
end

-- scale the help text frame to the right size and terminate OnUpdate
function Gamble_HelpFrame_OnUpdate(f, elapsed)
	local font, fontheight, flags = f:GetFont()
	local parent = f:GetParent()
	if f:GetNumLinesDisplayed() < f:GetNumMessages() and parent:GetHeight() <= 2500 then
		parent:SetHeight(parent:GetHeight() + fontheight)
	end
	--failsafe
	if f:GetNumLinesDisplayed() == f:GetNumMessages() or parent:GetHeight() >= 2500 then
		f:SetScript("OnUpdate", function() end)
		f:SetAlpha(1)
	end
end

-- fade announcement pane after certain time when the game ends
function Gamble_Announce_OnUpdate(frame, elapsed)
	if not GAMBLE_SAVED_VARS["gameinprogress"] then
		GAMBLE_ANNOUNCE_THROTTLE = GAMBLE_ANNOUNCE_THROTTLE + elapsed
		if GAMBLE_ANNOUNCE_THROTTLE >= 120 then
			local alpha = frame:GetAlpha()
			frame:SetAlpha(alpha - 0.002)
			if frame:GetAlpha() <= 0 then
				frame:Hide()
				frame:SetAlpha(1)
				GAMBLE_ANNOUNCE_THROTTLE = 0
			end
		end
	end
end

-- adjust slider value using mousewheel
function Gamble_Slider_MouseWheel(self, delta)
	local minValue, maxValue = self:GetMinMaxValues()
	if delta == 1 then
		if self:GetValue() < maxValue then
			self:SetValue(self:GetValue() + self:GetValueStep())
		end
	else
		if self:GetValue() > minValue then
			self:SetValue(self:GetValue() - self:GetValueStep())
		end
	end
end







