
-- Display the options
-- Gamble_OptionsButton_OnClick()

-- Closing options window and saving (or not)
-- Gamble_Options_Save(saving)

-- Alter the slider display appropriately
-- Gamble_Options_SliderChange(frame, mode)

-- Update your bid slider and foolproof the min/max sliders
-- Gamble_Options_MinMaxChance()

-- save statistics of individual players (active or not) in db
-- Gamble_SaveStats(name, items, gold, minroll, playing, winflag)

-- setup the menu for editting players in the stats page
-- Gamble_PlayerMenu_OnLoad()

-- Show menu for the specific player
-- Gamble_PlayerMenu_OnClick(self, button)

-- find target and confirm before deletion
-- Gamble_DeleteStats_OnClick(self, button)

-- find target and post stats to say or party/raid
-- Gamble_PostStats_OnClick(self, button)

-- delete the specified player from the db
-- Gamble_DeleteStats(character)

-- setup the db for a new name
-- Gamble_PrepareStats(truename)

-- create frames as needed and update with saved player stats
-- Gamble_StatFrame_Update()

-- Update the stat frame with the proper information
-- Gamble_StatFrame_UpdateVars(i, name, stats)


--[[********************************************************************************]]
--[[ Option Frame                                                                                                                        ]]
--[[********************************************************************************]]

--Display the options
function Gamble_OptionsButton_OnClick()
	_G["Gamble_Options_Frame"]:Show()
	
	-- Fill the frame with the saved values
	-- sliders
	_G["Gamble_Options_UncommonValue"]:SetValue(GAMBLE_DROP_VALUES["uncommon"])
	_G["Gamble_Options_RareValue"]:SetValue(GAMBLE_DROP_VALUES["rare"])
	_G["Gamble_Options_EpicValue"]:SetValue(GAMBLE_DROP_VALUES["epic"])
	_G["Gamble_Options_NonplayerValue"]:SetValue(GAMBLE_DROP_VALUES["nonplayer"])
	
	_G["Gamble_Options_MinBidValue"]:SetValue(GAMBLE_DROP_VALUES["minbid"])
	_G["Gamble_Options_MaxBidValue"]:SetValue(GAMBLE_DROP_VALUES["maxbid"])
	_G["Gamble_Options_YourBidValue"]:SetValue(GAMBLE_SAVED_VARS["bet"])
	
	_G["Gamble_Options_JeopardyChance"]:SetValue(GAMBLE_CONSTANTS["jeopardychance"])
	_G["Gamble_Options_DoubleItemChance"]:SetValue(GAMBLE_CONSTANTS["doubleitemchance"])
	_G["Gamble_Options_DrySpellLength"]:SetValue(GAMBLE_CONSTANTS["dryspelltime"])
	_G["Gamble_Options_MaxRoll"]:SetValue(GAMBLE_CONSTANTS["upperlimit"])
	
	--checkboxes
	_G["Gamble_Options_ChatMessage"]:SetChecked(GAMBLE_SAVED_VARS["chatmessage"])
	_G["Gamble_Options_FrameLock"]:SetChecked(GAMBLE_SAVED_VARS["locked"])
	_G["Gamble_Options_AnnounceToggle"]:SetChecked(GAMBLE_SAVED_VARS["announceframe"])
	_G["Gamble_Options_SaveXServerStats"]:SetChecked(GAMBLE_SAVED_VARS["savexserverstats"])
	_G["Gamble_Options_SaveStats"]:SetChecked(GAMBLE_SAVED_VARS["savestats"])
	_G["Gamble_Options_UseChaosOrb"]:SetChecked(GAMBLE_SAVED_VARS["usechaosorb"])
	_G["Gamble_Options_IgnoreSkips"]:SetChecked(GAMBLE_SAVED_VARS["ignoreskips"])
	_G["Gamble_Options_FrameHide"]:SetChecked(GAMBLE_SAVED_VARS["framehide"])
	_G["Gamble_Options_BossBonusRoll"]:SetChecked(GAMBLE_SAVED_VARS["bossbonusroll"])

	if GAMBLE_SAVED_VARS["savestats"] then
		_G["Gamble_Options_SaveXServerStats"]:Enable()
	else
		_G["Gamble_Options_SaveXServerStats"]:Disable()
	end

end

--Closing options window and saving (or not)
function Gamble_Options_Save(saving)
	if saving then
		-- Save all the values.. duh
		--sliders
		GAMBLE_DROP_VALUES["uncommon"] = _G["Gamble_Options_UncommonValue"]:GetValue()
		GAMBLE_DROP_VALUES["rare"] = _G["Gamble_Options_RareValue"]:GetValue()
		GAMBLE_DROP_VALUES["epic"] = _G["Gamble_Options_EpicValue"]:GetValue()
		GAMBLE_DROP_VALUES["nonplayer"] = _G["Gamble_Options_NonplayerValue"]:GetValue()

		GAMBLE_DROP_VALUES["minbid"] = _G["Gamble_Options_MinBidValue"]:GetValue()
		GAMBLE_DROP_VALUES["maxbid"] = _G["Gamble_Options_MaxBidValue"]:GetValue()
		GAMBLE_SAVED_VARS["bet"] = _G["Gamble_Options_YourBidValue"]:GetValue()
		
		GAMBLE_CONSTANTS["jeopardychance"] = _G["Gamble_Options_JeopardyChance"]:GetValue()
		GAMBLE_CONSTANTS["doubleitemchance"] = _G["Gamble_Options_DoubleItemChance"]:GetValue()
		GAMBLE_CONSTANTS["dryspelltime"] = _G["Gamble_Options_DrySpellLength"]:GetValue()
		GAMBLE_CONSTANTS["upperlimit"] = _G["Gamble_Options_MaxRoll"]:GetValue()
		
		--check boxes
		GAMBLE_SAVED_VARS["chatmessage"] = _G["Gamble_Options_ChatMessage"]:GetChecked()
		GAMBLE_SAVED_VARS["savexserverstats"] = _G["Gamble_Options_SaveXServerStats"]:GetChecked()
		GAMBLE_SAVED_VARS["savestats"] =  _G["Gamble_Options_SaveStats"]:GetChecked()
		GAMBLE_SAVED_VARS["locked"] = _G["Gamble_Options_FrameLock"]:GetChecked()
		GAMBLE_SAVED_VARS["announceframe"] = _G["Gamble_Options_AnnounceToggle"]:GetChecked()
		GAMBLE_SAVED_VARS["usechaosorb"] = _G["Gamble_Options_UseChaosOrb"]:GetChecked()
		GAMBLE_SAVED_VARS["ignoreskips"] = _G["Gamble_Options_IgnoreSkips"]:GetChecked()
		GAMBLE_SAVED_VARS["framehide"] = _G["Gamble_Options_FrameHide"]:GetChecked()
		GAMBLE_SAVED_VARS["bossbonusroll"] = _G["Gamble_Options_BossBonusRoll"]:GetChecked()
		
		if GAMBLE_SAVED_VARS["announceframe"] then
			if GAMBLE_SAVED_VARS["gameinprogress"] then
				Gamble_Announcement_Board:Show()
			end
		else
			Gamble_Announcement_Board:Hide()
		end
		
		if GAMBLE_SAVED_VARS["gameinprogress"] and not GAMBLE_SAVED_VARS["client"] then
			Gamble_Update_Rules()
		end
	else
		-- do stuff here that would be cancelling
	end
	_G["Gamble_Options_Frame"]:Hide()
end

-- Alter the slider display appropriately
function Gamble_Options_SliderChange(frame, mode)
	if mode == "percent" then
		_G[frame:GetName().."_Setting"]:SetText(frame:GetValue().."%")
	elseif mode == "gold" then
		_G[frame:GetName().."_Setting"]:SetText(GetCoinTextureString(frame:GetValue()))
	else
		_G[frame:GetName().."_Setting"]:SetText(frame:GetValue())
	end
end

-- Update your bid slider and foolproof the min/max sliders
function Gamble_Options_MinMaxChance()
	Gamble_Options_MinBidValue:SetMinMaxValues(100000, Gamble_Options_MaxBidValue:GetValue())
	Gamble_Options_MaxBidValue:SetMinMaxValues(Gamble_Options_MinBidValue:GetValue(), 800000)
	Gamble_Options_YourBidValue:SetMinMaxValues(Gamble_Options_MinBidValue:GetValue(), Gamble_Options_MaxBidValue:GetValue())
	
	_G[Gamble_Options_MinBidValue:GetName().."High"]:SetText(GetCoinTextureString(Gamble_Options_MaxBidValue:GetValue()))
	_G[Gamble_Options_MaxBidValue:GetName().."Low"]:SetText(GetCoinTextureString(Gamble_Options_MinBidValue:GetValue()))
	
	_G[Gamble_Options_YourBidValue:GetName().."High"]:SetText(GetCoinTextureString(Gamble_Options_MaxBidValue:GetValue()))
	_G[Gamble_Options_YourBidValue:GetName().."Low"]:SetText(GetCoinTextureString(Gamble_Options_MinBidValue:GetValue()))
end



--[[********************************************************************************]]
--[[ Stat Frame                                                                                                                           ]]
--[[********************************************************************************]]


-- save statistics of individual players (active or not) in db
function Gamble_SaveStats(name, items, gold, minroll, playing, winflag)
	local truename, _, realm = Gamble_GetFullName(name)
	
	if truename then
		if GAMBLE_SAVED_VARS["savexserverstats"] or realm == GetRealmName() then 
			Gamble_PrepareStats(truename)
			
			GAMBLE_STATS[truename]["items"] = GAMBLE_STATS[truename]["items"] + items
			GAMBLE_STATS[truename]["averageroll"] = ((GAMBLE_STATS[truename]["averageroll"] * GAMBLE_STATS[truename]["games"]) + minroll) / (GAMBLE_STATS[truename]["games"] + 1)
			GAMBLE_STATS[truename]["games"] = GAMBLE_STATS[truename]["games"] + 1
			
			if winflag then
				GAMBLE_STATS[truename]["wonlast"] = true
				GAMBLE_STATS[truename]["gold"] = GAMBLE_STATS[truename]["gold"] + gold
				GAMBLE_STATS[truename]["wins"] = GAMBLE_STATS[truename]["wins"] + 1
				GAMBLE_STATS[truename]["winstreak"] = GAMBLE_STATS[truename]["winstreak"] + 1
				GAMBLE_STATS[truename]["losestreak"] = 0
				
				if GAMBLE_STATS[truename]["winstreak"] > GAMBLE_STATS[truename]["longestwinstreak"] then
					GAMBLE_STATS[truename]["longestwinstreak"] = GAMBLE_STATS[truename]["winstreak"]
				end
			else
				if playing then
					GAMBLE_STATS[truename]["wonlast"] = false
					GAMBLE_STATS[truename]["gold"] = GAMBLE_STATS[truename]["gold"] - gold
					GAMBLE_STATS[truename]["losses"] = GAMBLE_STATS[truename]["losses"] + 1
					GAMBLE_STATS[truename]["losestreak"] = GAMBLE_STATS[truename]["losestreak"] + 1
					GAMBLE_STATS[truename]["winstreak"] = 0
					
					if GAMBLE_STATS[truename]["losestreak"] > GAMBLE_STATS[truename]["longestlosestreak"] then
						GAMBLE_STATS[truename]["longestlosestreak"] = GAMBLE_STATS[truename]["losestreak"]
					end
				end
			end
		end
	end
end

-- setup the menu for editting players in the stats page
function Gamble_PlayerMenu_OnLoad()
	--Setup player menu
	info = UIDropDownMenu_CreateInfo()
	info.text = GAMBLE_PLAYERMENU_POST
	info.func = Gamble_PostStats_OnClick
	info.notCheckable = 1
	UIDropDownMenu_AddButton(info)
	
	info = UIDropDownMenu_CreateInfo()
	info.text = GAMBLE_PLAYERMENU_DELETE
	info.func = Gamble_DeleteStats_OnClick
	info.notCheckable = 1
	UIDropDownMenu_AddButton(info)
end

--Show menu for the specific player
function Gamble_PlayerMenu_OnClick(self, button)
	--Call the menu
	GAMBLE_TARGETID = self:GetID()
	ToggleDropDownMenu(1, nil, Gamble_Options_FramePage2_PlayerMenu, "cursor")
end

-- find target and confirm before deletion
function Gamble_DeleteStats_OnClick(self, button)
	--find target name
	local character = _G["Gamble_Options_StatBox"..GAMBLE_TARGETID.."_Name_Full"]:GetText()
	
	--Character deletion popup setup
	StaticPopupDialogs["GambleCharacterDeleteConfirm"] = {
	text = format(GAMBLE_POPUP_CHARDELETECHECK, character),
	button1 = YES,
	button2 = NO,
	OnAccept = function (self) Gamble_DeleteStats(character) end,
	OnCancel = function (self) end,
	hideOnEscape = 1,
	timeout = 0,
	}
	
	-- ask
	StaticPopup_Show("GambleCharacterDeleteConfirm")
end

-- find target and post stats to say or party/raid
function Gamble_PostStats_OnClick(self, button)
	--find target name
	local character = _G["Gamble_Options_StatBox"..GAMBLE_TARGETID.."_Name_Full"]:GetText()
	local channel = "SAY"
	
	if GetRealNumRaidMembers() > 0 then
		channel = "RAID"
	elseif GetRealNumPartyMembers() > 0 then
		channel = "PARTY"
	end
	
	SendChatMessage("Gamble Statistics for "..character, channel)
	if GAMBLE_STATS[character]["gold"] < 0 then
		SendChatMessage(GetCoinText(math.abs(GAMBLE_STATS[character]["gold"])).." Lost", channel)
	elseif GAMBLE_STATS[character]["gold"] > 0 then
		SendChatMessage(GetCoinText(GAMBLE_STATS[character]["gold"]).." Won", channel)
	else
		SendChatMessage("Is breaking even.", channel)
	end
	if GAMBLE_STATS[character]["items"] == 1 then
		SendChatMessage(GAMBLE_STATS[character]["items"].." Item Won", channel)
	else
		SendChatMessage(GAMBLE_STATS[character]["items"].." Items Won", channel)
	end
	SendChatMessage("Avg Min Roll: "..round(GAMBLE_STATS[character]["averageroll"], 1), channel)
	SendChatMessage("W/L: "..GAMBLE_STATS[character]["wins"].."/"..GAMBLE_STATS[character]["losses"], channel)
	SendChatMessage("Winstreak: "..GAMBLE_STATS[character]["winstreak"].." ("..GAMBLE_STATS[character]["longestwinstreak"]..")", channel)
	SendChatMessage("Losestreak: "..GAMBLE_STATS[character]["losestreak"].." ("..GAMBLE_STATS[character]["longestlosestreak"]..")", channel)
end

-- delete the specified player from the db
function Gamble_DeleteStats(character)
	GAMBLE_STATS[character] = nil	
	DEFAULT_CHAT_FRAME:AddMessage(character.." is removed.")
	Gamble_StatFrame_Update()
end

--setup the db for a new name
function Gamble_PrepareStats(truename)
	if not GAMBLE_STATS[truename] then
		GAMBLE_STATS[truename] = {}
		GAMBLE_STATS[truename]["items"] = 0
		GAMBLE_STATS[truename]["averageroll"] = 0
		GAMBLE_STATS[truename]["gold"] = 0
		GAMBLE_STATS[truename]["wins"] = 0
		GAMBLE_STATS[truename]["losses"] = 0
		GAMBLE_STATS[truename]["games"] = 0
		GAMBLE_STATS[truename]["winstreak"] = 0
		GAMBLE_STATS[truename]["losestreak"] = 0
		GAMBLE_STATS[truename]["longestwinstreak"] = 0
		GAMBLE_STATS[truename]["longestlosestreak"] = 0
		GAMBLE_STATS[truename]["wonlast"] = false
	end
end

-- create frames as needed and update with saved player stats
function Gamble_StatFrame_Update()
	local i = 1
	
	local sortednames = {}
	table.foreach(GAMBLE_STATS, function(k) table.insert(sortednames, k) end)
	table.sort(sortednames)
	
	-- hide all stat frames to setup default
	local x = 1
	while _G["Gamble_Options_StatBox"..x] ~= nil do
		_G["Gamble_Options_StatBox"..x]:Hide()
		x = x + 1
	end
	
	for k2, v2 in ipairs(sortednames) do
		local k, v = v2, GAMBLE_STATS[v2]
		if _G["Gamble_Options_StatBox"..i] == nil then
			f = CreateFrame("FRAME", "Gamble_Options_StatBox"..i, Gamble_Options_FramePage2_WindowChild)
			f:SetBackdrop({
			bgFile="Interface\\Tooltips\\UI-Tooltip-Background", 
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			tile=1, tileSize=10, edgeSize=0, 
			insets={left=0, right=0, top=0, bottom=0}
			})
			f:SetBackdropColor(0, 0, 0, 0.6)
			f:SetBackdropBorderColor(0, 0, 0, 0)
			f:SetHeight(16)
			f:SetWidth(f:GetParent():GetWidth())
			f:Show()
			if i == 1 then
				f:SetPoint("TOPLEFT", Gamble_Options_FramePage2_WindowChild, "TOPLEFT", 0, 0)
			else
				f:SetPoint("TOPLEFT", _G["Gamble_Options_StatBox"..i-1], "BOTTOMLEFT", 0, -2)
			end
			
			--options button
			b = CreateFrame("BUTTON", "Gamble_Options_StatBox"..i.."_OptionsButton", _G["Gamble_Options_StatBox"..i])
			b:SetID(i)
			b:SetPoint("TOPLEFT")
			b:SetPoint("BOTTOMRIGHT")			
			b:SetScript("OnClick", function (self, button) Gamble_PlayerMenu_OnClick(self, button) end)
			
			--Name text box
			d = f:CreateFontString("Gamble_Options_StatBox"..i.."_Name")
			d:SetPoint("LEFT", _G["Gamble_Options_StatBox"..i], "LEFT", 2, 0)
			d:SetFontObject("GameFontHighlight")
			d:SetWidth(Gamble_Options_FramePage2_Name:GetWidth())
			d:SetHeight(20)
			d:SetJustifyH("LEFT")
			
			--Full Name text box
			d = f:CreateFontString("Gamble_Options_StatBox"..i.."_Name_Full")
			d:SetPoint("LEFT", _G["Gamble_Options_StatBox"..i], "LEFT", 2, 0)
			d:SetFontObject("GameFontHighlight")
			d:SetWidth(Gamble_Options_FramePage2_Name:GetWidth())
			d:SetHeight(20)
			d:SetJustifyH("LEFT")
			d:Hide()
						
			--Gold  text box
			d = f:CreateFontString("Gamble_Options_StatBox"..i.."_Gold")
			d:SetPoint("LEFT", _G["Gamble_Options_StatBox"..i.."_Name"], "RIGHT", -2, 0)
			d:SetFontObject("GameFontHighlight")
			d:SetWidth(Gamble_Options_FramePage2_Gold:GetWidth())
			d:SetHeight(20)
			d:SetJustifyH("CENTER")
			
			--Items won text box
			d = f:CreateFontString("Gamble_Options_StatBox"..i.."_Items")
			d:SetPoint("LEFT", _G["Gamble_Options_StatBox"..i.."_Gold"], "RIGHT", 0, 0)
			d:SetFontObject("GameFontHighlight")
			d:SetWidth(Gamble_Options_FramePage2_Items:GetWidth())
			d:SetHeight(20)
			d:SetJustifyH("CENTER")
			
			--Average Min Roll box
			d = f:CreateFontString("Gamble_Options_StatBox"..i.."_MinRoll")
			d:SetPoint("LEFT", _G["Gamble_Options_StatBox"..i.."_Items"], "RIGHT", 0, 0)
			d:SetFontObject("GameFontHighlight")
			d:SetWidth(Gamble_Options_FramePage2_MinRoll:GetWidth())
			d:SetHeight(20)
			d:SetJustifyH("CENTER")
			
			--Win/loss record
			d = f:CreateFontString("Gamble_Options_StatBox"..i.."_WinLoss")
			d:SetPoint("LEFT", _G["Gamble_Options_StatBox"..i.."_MinRoll"], "RIGHT", 0, 0)
			d:SetFontObject("GameFontHighlight")
			d:SetWidth(Gamble_Options_FramePage2_WinLoss:GetWidth())
			d:SetHeight(20)
			d:SetJustifyH("CENTER")
			
			--Win streak text box
			d = f:CreateFontString("Gamble_Options_StatBox"..i.."_WinStreak")
			d:SetPoint("LEFT", _G["Gamble_Options_StatBox"..i.."_WinLoss"], "RIGHT", 0, 0)
			d:SetFontObject("GameFontHighlight")
			d:SetWidth(Gamble_Options_FramePage2_WinStreak:GetWidth())
			d:SetHeight(20)
			d:SetJustifyH("CENTER")
			
			--Lose streak text box
			d = f:CreateFontString("Gamble_Options_StatBox"..i.."_LoseStreak")
			d:SetPoint("LEFT", _G["Gamble_Options_StatBox"..i.."_WinStreak"], "RIGHT", 0, 0)
			d:SetFontObject("GameFontHighlight")
			d:SetWidth(Gamble_Options_FramePage2_LoseStreak:GetWidth())
			d:SetHeight(20)
			d:SetJustifyH("CENTER")
			
		end
		
		--update the frame with info
		if v then
			Gamble_StatFrame_UpdateVars(i, k, v)
			_G["Gamble_Options_StatBox"..i]:Show()
			Gamble_Options_FramePage2_WindowChild:SetHeight(i * _G["Gamble_Options_StatBox1"]:GetHeight())
			i = i + 1
		end
	end
end

--Update the stat frame with the proper information
function Gamble_StatFrame_UpdateVars(i, name, stats)
	if stats["gold"] >= 0 then
		_G["Gamble_Options_StatBox"..i.."_Gold"]:SetText(GetCoinTextureString(stats["gold"]))
	else
		_G["Gamble_Options_StatBox"..i.."_Gold"]:SetText("|cFFFF0000"..GetCoinTextureString(math.abs(stats["gold"])).."|r")
	end
	_G["Gamble_Options_StatBox"..i.."_Items"]:SetText(stats["items"])
	_G["Gamble_Options_StatBox"..i.."_MinRoll"]:SetText(round(stats["averageroll"], 1))
	_G["Gamble_Options_StatBox"..i.."_WinLoss"]:SetText("|cFF00FF00"..stats["wins"].."|r".."/".."|cFFFF0000"..stats["losses"].."|r")
	_G["Gamble_Options_StatBox"..i.."_WinStreak"]:SetText("|cFF00FF00"..stats["winstreak"].."|r (|cFF00FF00"..stats["longestwinstreak"].."|r)")
	_G["Gamble_Options_StatBox"..i.."_LoseStreak"]:SetText("|cFFFF0000"..stats["losestreak"].."|r (|cFFFF0000"..stats["longestlosestreak"].."|r)")
	
	-- color frame
	local playerName = ""
	local realm = string.match(name, "- (%S+)$")
	
	if not realm then
		realm = GetRealmName()
	end
	
	if realm == GetRealmName() then
		playerName = string.match(name, "%a+")
	else
		playerName = name
	end

	_G["Gamble_Options_StatBox"..i.."_Name"]:SetText(playerName)
	_G["Gamble_Options_StatBox"..i.."_Name_Full"]:SetText(name)
	
	if UnitName("player") == playerName then
		_G["Gamble_Options_StatBox"..i]:SetBackdropColor(1, 0.8, 0, 0.6)			--you = gold bg
	elseif UnitInParty(playerName) or UnitInRaid(playerName) then
		_G["Gamble_Options_StatBox"..i]:SetBackdropColor(0.2, 0.2, 0.8, 0.6)		--same party = blue bg
	elseif GetRealmName() == realm then
		_G["Gamble_Options_StatBox"..i]:SetBackdropColor(0, 0.8, 0, 0.6)			--same server = green bg
	else
		_G["Gamble_Options_StatBox"..i]:SetBackdropColor(0, 0, 0, 0.6)				--everyone else = default grey bg
	end
end


